# AR1300
# Script adds Contact first name and last name to Multiple contact grid on AR Customer

from accpac import *

vMTCONC = None

def main(args):
	MyUI()

class MyUI(UI):
	def __init__(self):
		UI.__init__(self)
		self.createScreen()

	def createScreen(self):
		# use Sage UI Info and/or File Customize on the AR1300 screen to confirm the grid name
		grid = self.getHostControl("avlARCUSMTcontacts")
		self.grid = grid
		#add a column , hijack a valid column name on the data source, in this case EMAIL column
		# you can use the same column for both fields as it is the same data type
		col = UIGridColumn()
		col.caption = "First Name"
		col.hasFinder = False
		col.isEditable = False
		grid.addColumn(col, "EMAIL")
		
		col = UIGridColumn()
		col.caption = "Last Name"
		col.hasFinder = False
		col.isEditable = False
		grid.addColumn(col, "EMAIL")

		grid.setOnGetText(self.onGridGetText)
		
		# use UI Info to confirm data source name for Customer Multiple contact 
		self.dsDetail = self.openDataSource("adsARCUSMT")
		#grid.refreshData()
		self.show()

	def onGridGetText(self, e):
		global vMTCONC
		# save the Contact ID
		sIDContact = self.dsDetail.get("IDCONTACT")
		
		# use the Contact ID to read the details in the Multiple contact table in getContactDetails function
		if vMTCONC == None:
			vMTCONC = openView("MT0100")

		if e.caption == "First Name":
			if (sIDContact != ""):
				e.value = self.getContactDetails(sIDContact, "First Name")
			
		if e.caption == "Last Name":
			# set default value:
			# read key value from data source
			if (sIDContact != ""):
				e.value = self.getContactDetails(sIDContact, "Last Name")
	
	def getContactDetails(self,sIDContact, sCaption):
	# use the Contact ID to read the details in the Multiple contact table,
		vMTCONC.recordClear()
		vMTCONC.put("IDCONTACT", sIDContact)
		if vMTCONC.read() == 0:
			sFirstName = vMTCONC.get("FIRSTNAME")
			sLastName = vMTCONC.get("LASTNAME")
			if (sCaption == "First Name"): 
				return sFirstName
			if (sCaption == "Last Name"):
				return sLastName
		else: 
			return "not OK"